<template>
  <crud-data-table-form-dialog
    v-model="dialog"
    :loading="isLoading"
    :dialog-title="$t('dialogTitle')"
    :dialog-subtitle="$t('dialogSubtitle')"
    @onClose="onCloseDialog"
    @onSave="onSave"
  >
    <v-form
      ref="form"
      @submit.prevent
    >
      <title-field
        v-model="form.title"
        required
        autofocus
        :disabled="isLoading"
        @keypress.enter="onSave"
      />
      <date-picker-range-field
        v-model="form.dates"
        required
        @reset="resetCalendarCallback = $event"
      />
    </v-form>
  </crud-data-table-form-dialog>
</template>

<script>
  const START_DATE = 0
  const END_DATE = 1

  export default {
    name: 'CreatePeriodDialog',
    data () {
      return {
        form: {
          title: '',
          dates: [],
        },
        dialog: false,
        isLoading: false,
        resetCalendarCallback: null,
      }
    },
    methods: {
      closeDialogAndCleanForm () {
        this.dialog = false
        this.$refs.form.reset()
        this.resetCalendarCallback()
      },
      onSave () {
        if (this.$refs.form.validate()) {
          this.isLoading = true
          const { title, dates } = this.form
          this.$store.dispatch('periods/createPeriod', {
            title,
            startDate: dates[START_DATE],
            endDate: dates[END_DATE],
          })
            .then(() => {
              this.closeDialogAndCleanForm()
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('createSuccess'),
              })
            })
            .catch(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'error',
                text: this.$t('createError'),
              })
            })
            .finally(() => {
              this.isLoading = false
            })
        }
      },
      onCloseDialog () {
        this.closeDialogAndCleanForm()
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          dialogTitle: 'Cadastro de período',
          dialogSubtitle: 'Informe o novo período com título, data inicial e data final.',
          createSuccess: 'Período adicionado com sucesso!',
          createError: 'Ops... Algo deu errado ao tentar adicionar o período. Por favor, tente novamente.',
        },
        'en-US': {
          dialogTitle: 'Period registration',
          dialogSubtitle: 'Enter the new period with title, start and end date.',
          createSuccess: 'Period successfully added!',
          createError: 'Oops... Something went wrong while trying to add the period. Please try again.',
        },
      },
    },
  }
</script>
